/*
	r25:r24 - input param
	r26:r27 - interrupt registers
	r2,r18 		- auxiliary register
*/

#include <avr/io.h>

.global wait_ms
wait_ms:
	cli
	mov		r26,r24
	mov		r27,r25
;
	ldi		r18, (1<<CS01);
	out		_SFR_IO_ADDR(TCCR0B),r18	; TCCR0B=(1<<CS8),prescaler =8
	ldi		r18, (1<<OCIE0A)
	out		_SFR_IO_ADDR(TIMSK0),r18	; TIMSK0=(1<<OCIE0A), enable interrupt
loop:
	sei
	sleep
	cli
	mov	r2,r26
	or	r2,r27
	breq away_from_wait_ms
	rjmp loop
away_from_wait_ms:
	eor		r18,r18						; r18=0
	out		_SFR_IO_ADDR(TIMSK0),r18	; TIMSK0=0
	out		_SFR_IO_ADDR(TCCR0B),r18	; TCCR0B=0
	ret
