#include "avr/io.h"

.org 0
.section .vectors
vectors:
    rjmp   reset	                    ; Reset Handler
    rjmp   INT0_vect                    ; IRQ0 Handler
    rjmp   PCINT0_vect                  ; PCINT0 Handler
    rjmp   vectors                      ; Timer0 Overflow Handler
    rjmp   vectors                      ; EEPROM Ready Handler
    rjmp   vectors                      ; Analog Comparator Handler
    rjmp   TIM0_COMPA_vect              ; Timer0 CompareA Handler
    rjmp   vectors                      ; Timer0 CompareB Handler
    rjmp   vectors                      ; Watchdog Interrupt Handler
    rjmp   vectors                      ; ADC Conversion Handler

; Reset Handler
reset:
    eor     r16,r16                     ; r=0;
    out     _SFR_IO_ADDR(SREG),r16      ; clean Status Register
    ldi     r16, RAMEND                 ; r16=0x9f
    out     _SFR_IO_ADDR(SPL),r16       ; Set Stack Pointer to top of RAM
	rjmp	lets

; IRQ0 Handler
.global INT0_vect
INT0_vect:
	in 	r12, _SFR_IO_ADDR(SREG) 		; save SREG
	add	r4, r11
	adc r5, r10		  					; (r4:r5)++, r10=0
	out _SFR_IO_ADDR(SREG), r12			; restore SREG
	reti

; PCINT0 Handler
.global PCINT0_vect
PCINT0_vect:
    in  r7,_SFR_IO_ADDR(SREG)
    push r7                             ; save SREG
	push r24
	sbis 0x16,0							; if (PINB & (1<<PB0))
	rjmp	m1							; then
	ldi  r24,(1<<PCIE)
	out _SFR_IO_ADDR(GIMSK),r24			; GIMSK=0 , disable INT0 interrupt
	sts 0x0060,r4
	sts 0x0061,r5
	rjmp	m2
m1:										; else
	ldi	r24,(1<<PCIE)|(1<<INT0)
	out _SFR_IO_ADDR(GIMSK),r24 		; GIMSK=(1<<INT0), enable INIT0 interrupt
	eor	r4,r4
	eor r5,r5							; (r4:r5)=0
	eor r10,r10
	eor r11,r11
	inc r11
m2:
	pop r24
    pop  r7
    out _SFR_IO_ADDR(SREG), r7          ; restore SREG

    reti

; Timer0 CompareA Handler
.global TIM0_COMPA_vect
TIM0_COMPA_vect:
	inc r3;								;set flag
	reti

.section .start0
lets:

.section .start1
lets_go:
	rjmp main
